#pragma once


#include <LearnOpenGL/Animation.h>
#include <LearnOpenGL/Bone.h>
#include <vector>
#include <J3ML/LinearAlgebra/Matrix4x4.h>
#include <string>
#include <assimp/scene.h>
#include <assimp/Importer.hpp>


namespace LearnOpenGL
{
    using J3ML::LinearAlgebra::Matrix4x4;

    class Animator
    {
    public:
        Animator() {}
        Animator(Animation* animation);
        void UpdateAnimations(float dt);
        void PlayAnimation(Animation* pAnimation);
        void CalculateBoneTransform(const AssimpNodeData* node, Matrix4x4 parentTransform);
        std::vector<Matrix4x4> GetFinalBoneMatrices();
    private:
        std::vector<Matrix4x4> FinalBoneMatrices;
        Animation* CurrentAnimation;
        float CurrentTime;
        float DeltaTime;
    };
}