#pragma once

#include <vector>
#include <LearnOpenGL/Vertex.h>
#include <glad/glad.h>

// TODO: Bring upstream of Re3D::VertexArray
namespace LearnOpenGL
{
    class VertexArray {
    private:
        std::vector<Vertex> boundingVolume;
    public:
        std::string name;
        std::vector<Vertex> vertices;
        std::vector<unsigned int> indices;
        VertexArray getBoundingVolume(Vector3 angle);
        void rotate(const Vector3& angle);
        void load(const std::string& filename);
        static void erase(const VertexArray& vArray);
        void drawWireframe();
        void draw();
        GLuint vbo = NULL;
    };
}