#pragma once

namespace LearnOpenGL
{
    /// Describes how this buffer is intended to be used.
    enum class Usage
    {
        Stream,  // Constantly changing data
        Dynamic, // Occasionally changing data (Good compromise)
        Static   // Rarely changing data
    };

    enum class PrimitiveType{
        Points,
        Lines,
        LineStrip,
        Triangles,
        TriangleStrip,
        TriangleFan,
        Quads,
    };


    class VertexBuffer
    {
    public:
        u32 RendererID;
        VertexBuffer(const void* data, u32 size)
        {
            glGenBuffers(1, &RendererID);
        }
        ~VertexBuffer()
        {
            glDeleteBuffers(1, &RendererID);
        }

        void Bind() const
        {
            glBindBuffer(GL_ARRAY_BUFFER, RendererID);
        }

        void Unbind() const
        {
            glBindBuffer(GL_ARRAY_BUFFER, 0);
        }




    public:

    };
}